#include <math.h>
#include "Vector.h"


template <int ndim>
Vector<ndim>::Vector()
{
  for (int k=0; k<ndim; k++) v[k] = 0.0f;
}


template <int ndim>
Vector<ndim>::~Vector()
{
}


template <int ndim>
float Vector<ndim>::Magnitude()
{
  int k;
  float magsqd = 0.0f;
  for (k=0; k<ndim; k++) magsqd += v[k]*v[k];
  return sqrtf(magsqd);
}


template <int ndim>
Vector<ndim> Vector<ndim>::UnitVector(void)
{
  int k;
  float mag = Magnitude();
  Vector<ndim> unitVector;
  for (k=0; k<ndim; k++) unitVector.v[k] = v[k] / mag;
  return unitVector;
}


template class Vector<1>;
template class Vector<2>;
template class Vector<3>;
