// To compile : g++ -o Vector.exe Vector.cpp main.cpp
#include <iostream>
#include "Vector.h"

template <int ndim>
float dot_product(Vector<ndim> a, Vector<ndim> b) {
  float result = 0.0;
  for (int k=0; k<ndim; k++) result += a.v[k]*b.v[k];
  return result;
}

int main()  {
  Vector<1> v1, v2;
  Vector<2> v3, v4;
  v1.v[0] = 2.0f;
  v2.v[0] = 4.0f;
  v3.v[0] = 2.0f;  v3.v[1] = 1.0f;
  v4.v[0] = 4.0f;  v4.v[1] = 2.0f;

  std::cout << "Dot product (1d) : " << dot_product(v1, v2) << std::endl;
  std::cout << "Dot product (2d) : " << dot_product(v3, v4) << std::endl;

  return 0;
}
